Packages - Bug #2139

Updating [libidn2] breaks [libre/systemd] may lead to unbootable system
2019-01-16 02:41 AM - freemor

Status: fixed % Done: 90%
Priority: broken

Assignee: bill-auger

Category:

Description

Tonight | pacman -Suy 'd and there was an update for libidn2 from Arch. This immediately broke [libre/systemd] causing most
systemd commands to error out with "can't find libidn2.s0.0"

| was able to work around it with:
sudo 1ln -s /usr/lib/libidn2.so /usr/lib/libidn2.s0.0
This will most likely result in a borked system if the user forces a reboot without fixing it first.

e |ibre/systemd NEEDS a rebuild
¢ A warning of the issue and workaround instruction should be put in prevalent places until rebuild happens.

History

#1 - 2019-01-16 09:48 AM - daniel_-

The workaround isn't working for me, it still states on boot

error while loading share libraries: libidn2.s0.0 cannot open shared object file: no such file or directory
Interestingly, later it states (/dev/sdal is my root)

error device '/dev/sdal' not found. skipping fsck.

mounting '/dev/sdal' on real root

mount: /new_root: no filesystem specified

In the emergency shell | am dropped into | have no keyboard input. How significant this is to the problem at hand, no idea.

The symlink was done inside a chroot, the current state of the symlinks

libidn2.s0o->1ibidn2.s0.4.0.0
libidn2.s0.0->1ibidn2.so

#2 - 2019-01-16 09:52 AM - daniel_-

Additionally | had downgraded libidn2 to version 2.0.5-1, have since gone back to 2.1.0-1 in a blind hope to bypass the problem (this was after the
workaround initially not working, however)

#3 - 2019-01-16 12:25 PM - freemor

My system with the work around | did works and reboots fine. All | did was the single Is -s stated above
this results in:

[freemor@freelap ~]$ 1ls -lh /usr/lib/libidn2*

lrwxrwxrwx 1 root root 16 Jan 13 15:20 /usr/lib/libidn2.so -> libidn2.s0.4.0.0%*
lrwxrwxrwx 1 root root 19 Jan 15 23:08 /usr/lib/libidn2.s0.0 -> /usr/lib/libidn2.so*
lrwxrwxrwx 1 root root 16 Jan 13 15:20 /usr/lib/libidn2.s0.4 -> libidn2.s0.4.0.0*
1

—TWXIr—XIr—X root root 118K Jan 13 15:20 /usr/lib/libidn2.s0.4.0.0%*

on my system. which | am posting the BR and Update from.

#4 - 2019-01-16 12:43 PM - daniel_-

System boots now after running
mkinitcpio -p linux-libre

#5 - 2019-01-16 02:02 PM - infertux

This will most likely result in a borked system if the user forces a reboot without fixing it first.

Can confirm, my battery ran out shortly after this update and my laptop powered down. Then Parabola would kernel panic upon reboot.

In -s /usr/lib/libidn2.so /ust/lib/libidn2.s0.0

Thankfully, | was able to boot from a live USB and this fixed it for me, thanks @freemor.

#6 - 2019-01-16 05:18 PM - GNUtoo

I've pushed the fix in git but we also need to build it.

#7 - 2019-01-16 05:54 PM - GNUtoo
I've pushed x86_64 binaries, I'll push i686 binaries real soon, then ARM

#8 - 2019-01-16 08:36 PM - bill-auger
then there are several other dependents - these probably all need to be rebuilt:
$ sudo pacman —-Sii libidn2 | grep Required

Required By : bind-tools dnsmasg getdns gmime3 gnutls iputils knot libpsl mutt s-nail
systemd-common wget whois

also eli offered a custom script that can identify any built package that links to it, regardless of the metedata
https://qgithub.com/eli-schwartz/dotfiles/blob/master/bin/pkg-list-linked-libraries

#9 - 2019-01-16 09:22 PM - freemor

bind-tools dnsmasq getdns gmime3 gnutls iputils knot libpsl mutt s-nail wget whois <- All come from Arch repos and thus are probably rebuilt already
or are in the process of.

systemd-common is at par2 so was rebuilt when oaken-source rebuilt systemd

#10 - 2019-01-18 03:16 PM - GNUtoo

I've updated systemd by moving the libre-testing version to libre.
So far with this version:

® {686 doesn't build due to a failing test (#2143)
e armv7h does build find but I've some issues uploading it:

$ librerelease -1
-> libre
libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-common-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-debug-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-libudev-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-nss-myhostname-240.34-3.parabolal-armv/h.pkg.tar.xz
systemd-nss—-mymachines-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-nss—-resolve-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-nss—-systemd-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-resolvconf-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-sysvcompat-240.34-3.parabolal-armv7h.pkg.tar.xz
systemd-udev-240.34-3.parabolal-armv7h.pkg.tar.xz
-> sources
parabola/systemd-240.34-3.parabolal-armv7h.src.tar.gz
$ librerelease
==> Running HOOKPRERELEASE...
$ ssh —-fN -p 1863 gnutoo@repo.parabola.nu
==> Signing package...
—> Created signature file /home/gnutoo/packages/staging/libre/systemd-240.34-3.parabolal-armv7h.pkg.tar.
RIZPYSEilci
==> Signing package...
—> Created signature

g.tar.xz.sig.

==> Signing package...
—> Created signature

armv7h.pkg.tar.xz.sig.

==> Signing package...
—> Created signature

kg.tar.xz.sig.

==> Signing package...
—> Created signature

pkg.tar.xz.sig.

==> Signing package...
—> Created signature

v7h.pkg.tar.xz.sig.

==> Signing package...
—> Created signature

v7h.pkg.tar.xz.sig.

==> Signing package...
—> Created signature

.tar.xz.sig.

==> Signing package...
—> Created signature

7Th.pkg.tar.xz.sig.

==> Signing package...
—> Created signature

7Th.pkg.tar.xz.sig.

==> Signing package...
—> Created signature

7Th.pkg.tar.xz.sig.

==> Signing package...
—> Created signature

armv7h.pkg.tar.xz.sig.

==> Signing package...
—> Created signature

ar.xz.sig.

==> Signing package...
—> Created signature

7Th.src.tar.gz.sig.

==> 224M to upload

file

file

file

file

file

file

file

file

file

file

file

file

file

==> Uploading packages...

building file list
31 files to consider

/home/gnutoo/packages/staging/libre/systemd-debug-240.34-3.parabolal-armv7h.pk

/home/gnutoo/packages/staging/libre/systemd-nss-myhostname-240.34-3.parabolal~-

/home/gnutoo/packages/staging/libre/systemd-common-240.34-3.parabolal-armv7h.p

/home/gnutoo/packages/staging/libre/systemd-1libudev-240.34-3.parabolal-armv7h.

/home/gnutoo/packages/staging/libre/systemd-nss-resolve-240.34-3.parabolal-arm

/home/gnutoo/packages/staging/libre/systemd-nss—systemd-240.34-3.parabolal-arm

/home/gnutoo/packages/staging/libre/systemd-udev-240.34-3.parabolal-armv7h.pkg

/home/gnutoo/packages/staging/libre/systemd-1libsystemd-240.34-3.parabolal-armv

/home/gnutoo/packages/staging/libre/systemd-resolvconf-240.34-3.parabolal-armv

/home/gnutoo/packages/staging/libre/systemd-sysvcompat-240.34-3.parabolal-armv

/home/gnutoo/packages/staging/libre/systemd-nss-mymachines-240.34-3.parabolal~-

/home/gnutoo/packages/staging/libre/libsystemd-240.34-3.parabolal-armv7h.pkg.t

/home/gnutoo/packages/staging/sources/parabola/systemd-240.34-3.parabolal-armv

libre/libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz

2.60K 100%

1.82MB/s

0:00:00 (xfr#l, to-chk=29/31)

libre/libsystemd-240.34-3.parabolal-armv’h.pkg.tar.xz.sig

566 100%

552.73kB/s

0:00:00 (xfr#2, to-chk=28/31)

libre/systemd-240.34-3.parabolal-armv7h.pkg.tar.xz

2.54M 100%

100.81MB/s

0:00:00 (xfr#3, to-chk=27/31)

libre/systemd-240.34-3.parabolal-armv7h.pkg.tar.xz.sig

566 100%

23.03kB/s

0:00:00 (xfr#4, to-chk=26/31)

libre/systemd-common—-240.34-3.parabolal-armv7h.pkg.tar.xz

624.33K 100%

19.85MB/s

0:00:00 (xfr#5, to-chk=25/31)

libre/systemd-common-240.34-3.parabolal-armv7h.pkg.tar.xz.sig

566 100%

18.42kB/s

0:00:00 (xfr#6, to-chk=24/31)

libre/systemd-debug-240.34-3.parabolal-armv7h.pkg.tar.xz

12.03M 100%

37.01MB/s

0:00:00 (xfr#7, to-chk=23/31)

libre/systemd-debug-240.34-3.parabolal-armv’h.pkg.tar.xz.sig

566 100%

1.78kB/s

0:00:00 (xfr#8, to-chk=22/31)

libre/systemd-libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz

482.13K 100%

1.46MB/s

0:00:00 (xfr#9, to-chk=21/31)

libre/systemd-libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz.sig

566 100% 1.75kB/s 0:00:00 (xfr#10, to-chk=20/31)
libre/systemd-libudev-240.34-3.parabolal-armv7h.pkg.tar.xz

77.43K 100%
libre/systemd-libudev-

239.
240.

28kB/s
34-3.parabolal-armv7h.pkg.tar.xz.sig

0:00:00 (xfr#ll, to-chk=19/31)

566 100% 1.75kB/s 0:00:00 (xfr#l12, to-chk=18/31)
libre/systemd-nss-myhostname-240.34-3.parabolal-armv7h.pkg.tar.xz
34.96K 100% 107.71kB/s 0:00:00 (xfr#13, to-chk=17/31)

libre/systemd-nss-myhostname-240.34-3.parabolal-armv’h.pkg.tar.xz.sig
566 100% 1.74kB/s 0:00:00 (xfr#14, to-chk=16/31)
libre/systemd-nss-mymachines-240.34-3.parabolal-armv7h.pkg.tar.xz
115.70K 100% 355.31kB/s 0:00:00 (xfr#15, to-chk=15/31)

libre/systemd-nss-mymachines-240.34-3.parabolal-armv7h.pkg.tar.xz.sig
566 100% 1.74kB/s 0:00:00 (xfr#l6, to-chk=14/31)
libre/systemd-nss—-resolve-240.34-3.parabolal-armv’h.pkg.tar.xz

114.07K 100% 349.20kB/s 0:00:00 (xfr#l17, to-chk=13/31)
libre/systemd-nss-resolve-240.34-3.parabolal-armv7h.pkg.tar.xz.sig
566 100% 1.73kB/s 0:00:00 (xfr#18, to-chk=12/31)

libre/systemd-nss—-systemd-240.34-3.parabolal-armv7h.pkg.tar.xz
114.46K 100% 349.29kB/s 0:00:00 (xfr#19, to-chk=11/31)
libre/systemd-nss—-systemd-240.34-3.parabolal-armv’h.pkg.tar.xz.sig
566 100% 1.73kB/s 0:00:00 (xfr#20, to-chk=10/31)

libre/systemd-resolvconf-240.34-3.parabolal-armv7h.pkg.tar.xz
2.90K 100% 8.83kB/s 0:00:00 (xfr#21, to-chk=9/31)
libre/systemd-resolvconf-240.34-3.parabolal-armv7h.pkg.tar.xz.sig

566 100% 1.72kB/s 0:00:00 (xfr#22, to-chk=8/31)
libre/systemd-sysvcompat-240.34-3.parabolal-armv7h.pkg.tar.xz
8.18K 100% 24.87kB/s 0:00:00 (xfr#23, to-chk=7/31)
libre/systemd-sysvcompat-240.34-3.parabolal-armv7h.pkg.tar.xz.sig
566 100% 1.72kB/s 0:00:00 (xfr#24, to-chk=6/31)
libre/systemd-udev-240.34-3.parabolal-armv7h.pkg.tar.xz
935.81K 100% 2.71MB/s 0:00:00 (xfr#25, to-chk=5/31)
libre/systemd-udev-240.34-3.parabolal-armv7h.pkg.tar.xz.sig
566 100% 1.68kB/s 0:00:00 (xfr#26, to-chk=4/31)
sources/parabola/systemd-240.34-3.parabolal-armv7h.src.tar.gz
216.80M 100% 264.52kB/s 0:13:20 (xfr#27, to-chk=1/31)
sources/parabola/systemd-240.34-3.parabolal-armv7h.src.tar.gz.sig
566 100% 552.73kB/s 0:00:00 (xfr#28, to-chk=0/31)

==> Removing files from local staging directory

removed 'libre/systemd-nss-mymachines-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'
removed 'libre/systemd-240.34-3.parabolal-armv7h.pkg.tar.xz'

removed 'libre/systemd-debug-240.34-3.parabolal-armv’h.pkg.tar.xz'

removed 'libre/systemd-nss-myhostname-240.34-3.parabolal-armv7h.pkg.tar.xz'
removed 'libre/systemd-common-240.34-3.parabolal-armv7h.pkg.tar.xz'

removed 'libre/systemd-libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz.sig’
removed 'libre/systemd-common-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'
removed 'libre/systemd-libudev-240.34-3.parabolal-armv7h.pkg.tar.xz'
removed 'libre/systemd-nss-resolve-240.34-3.parabolal-armv7h.pkg.tar.xz'
removed 'libre/systemd-debug-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'
removed 'libre/systemd-resolvconf-240.34-3.parabolal-armv7h.pkg.tar.xz.sig"'
removed 'libre/systemd-nss—-systemd-240.34-3.parabolal-armv’h.pkg.tar.xz'
removed 'libre/systemd-udev-240.34-3.parabolal-armv7h.pkg.tar.xz'

removed 'libre/systemd-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'

removed 'libre/systemd-nss-myhostname-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'
removed 'libre/systemd-nss-resolve-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'
removed 'libre/libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'
removed 'libre/systemd-nss—-systemd-240.34-3.parabolal-armv’h.pkg.tar.xz.sig'

removed 'libre/systemd-libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz'

removed 'libre/systemd-resolvconf-240.34-3.parabolal-armv’h.pkg.tar.xz'

removed 'libre/systemd-sysvcompat-240.34-3.parabolal-armv7h.pkg.tar.xz"'

removed 'libre/systemd-udev-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'

removed 'libre/systemd-nss-mymachines-240.34-3.parabolal-armv7h.pkg.tar.xz'

removed 'libre/systemd-libudev-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'

removed 'libre/systemd-sysvcompat-240.34-3.parabolal-armv7h.pkg.tar.xz.sig'

removed 'libre/libsystemd-240.34-3.parabolal-armv7h.pkg.tar.xz'

removed 'sources/parabola/systemd-240.34-3.parabolal-armv7h.src.tar.gz.sig'

removed 'sources/parabola/systemd-240.34-3.parabolal-armv7h.src.tar.gz'

==> Running db-update on repos

==> WARNING: file already exists: sources/parabola/systemd-240.34-3.parabolal-armv7h.src.tar.gz.sig
removed 'sources/parabola/systemd-240.34-3.parabolal-armv7h.src.tar.gz'

==> ERROR: Package libre/libsystemd-239.370-1.par2-x86_64.pkg.tar.xz already exists in another repository

==> Removing left over lock from [libre] (x86_64)

==> Removing left over lock from [libre] (i686)

==> Removing left over lock from [libre] (armv7h)
(

==> Removing left over lock from [libre] (ppcé64dle)

==> ERROR: An unknown error has occurred. Exiting...
User defined signal 1

#11 - 2019-01-19 03:35 AM - bill-auger

- Status changed from open to fixed

that librerelease report looks fine to me - the error shows that you had a x86_64 package mixed in - that was probably non-fatal

anyways, i think we solved the libidn2 issue - so ill close this BR
#12 - 2019-02-12 05:54 AM - bandali

The issue (or a similar one) seems to have resurfaced with the latest libidn2 update:
$ journalctl -xe

journalctl: error while loading shared libraries: libidn2.so0.4: cannot open shared object file: No such file o
r directory

Also affects things like suspending, and likely hibernation and start up as well.

My temporary workaround:

sudo 1ln -s /usr/lib/libidn2.so /usr/lib/libidn2.so.4

#13 - 2019-02-12 08:05 AM - bill-auger

- Status changed from fixed to unconfirmed

sure love the sensible versioning scheme

libidn2-2.1.0-1:

/usr/lib/libidn2.so

/usr/lib/libidn2.s0.4

/usr/lib/libidn2.s0.4.0.0*

libidn2-2.1.1-2:

/usr/lib/libidn2.so

/usr/lib/libidn2.s0.0
/usr/lib/libidn2.s0.0.3.4

#14 - 2019-02-12 04:20 PM - xrchz

- Status changed from unconfirmed to confirmed

| can confirm the issue reported by bandali above, and that it leads to an unbootable system.
| just recovered my system following bandali's fix from a recovery shell.

#15 - 2019-02-12 06:57 PM - eschwartz

ttps //qn archlmux orq/svntomt/oackaqes mt/commn/trunk’?h oackanes/curl&|d 6700217480b9262f15770401ddf899b249ba0348

https:/git.archlinux.org/svntogit/packages.git/commit/trunk ?h=packages/systemd&id=bac19afd64db3d53646fca6782a06057a9e221aa

As of now, many arch packages depend on libidn2.so which is provided by libidn, and makepkg will automatically create soname-versioned
dependency links to prevent partial updates. The recent soname changes by upstream are too ridiculous it seems.

So the parabola systemd package can be updated to parallel the archlinux systemd package, as can any other parabola-specific packages which are
breaking because of libidn2.

#16 - 2019-02-13 07:38 AM - bill-auger
i have added the 'libidn2.s0' dependency to the 'systemd-common' split package
[i686]

libidn2 2.1.1-2 for i686 is still in [staging] - a 'systemd' package with the 'libidn2.so' dependency, built against the libidn2 in [staging] (2.1.1) is in
[libre-testing] now (240.95-1.parabola5)

[x86_64]

a re-build for x86_64 was published earlier today without the libidn2 soname dep - that has also been rebuilt in [libre-testing] (240.95-1.parabola2) -
just needs to be verified

[armv7h]
libidn2 2.1.1 is already in archarm - but systemd is FTBS for arm because curl, gnutls, and libpsl conflict with the new libidn2 - i tried again using a

repo backup from 2019-02-09 - that allowed the build, but then failed during the check() function - GNUtoo rebuilt it on ARM hardware - that is in
[libre] now (240.95-1.parabola3)

#17 - 2019-02-13 07:39 AM - bill-auger

- Status changed from confirmed to in progress

#18 - 2019-02-14 09:15 AM - bill-auger
- % Done changed from 0 to 90

#19 - 2019-02-21 09:45 AM - GNUtoo

This is fixed now.

| did:

Pacman —-Syuu
systemctl

And that worked on armv7h i686, x86_64

| also verified that no workaround symlink was there with:

# pacman -Q -1 libidn2 | grep "/usr/lib/libidn2\.so\."
1s -1 /usr/lib/libidn2.so*

While I'm at it, here are the versions:
armv7h: libidn2.s0.0.3.5

i686: libidn2.s0.4.0.0

x86_64: libidn2.s0.0.3.5

#20 - 2019-02-21 09:46 AM - GNUtoo
- % Done changed from 90 to 100

#21 - 2019-02-21 09:48 AM - GNUtoo
- Assignee set to GNUtoo

#22 - 2019-02-21 09:48 AM - GNUtoo

- Status changed from in progress to fixed

#23 - 2019-02-21 10:24 AM - bill-auger

i left this ticket open for a reason - the moment arch32 moves the new libidn2 out of staging, this BR will be completely relevant again immediately,
until the systemd 240.95-1.parabola5 that is built against the new libidn2 is moved to libre - that was in [libre-testing] but it appears that someone
deleted it?

#24 - 2019-02-21 12:46 PM - bill-auger

- % Done changed from 100 to 90

- Assignee changed from GNUtoo to bill-auger

- Status changed from fixed to in progress

#25 - 2019-02-22 08:21 AM - bill-auger

update:

[i686]

libidn2 for i686 is still in [staging] - it has now been upgraded to libidn2-2.1.1-2.2

a rebuilt 'systemd' package with the 'libidn2.so' dependency, built against the next libidn2 is in [libre-testing] now (systemd-240.95-2.par2)

as soon as the next libidn2 comes out of [staging], we should be able to simply "db-move™ systemd-240.95-2.par2 from [libre-testing] to [libre], and all
should go smoothly

#26 - 2019-10-25 04:21 PM - Anonymous

Still work in progress?

#27 - 2019-11-03 12:50 PM - bill-auger

- Status changed from in progress to fixed

yep this hurdle has passed
